////////////////////////////////////////////////////////////////////////////////
// EnumEntry.h : Declaration of the EnumEntry
//
// Updated: 3rd December 2005

#ifndef __ENUMENTRY_H_
#define __ENUMENTRY_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// EnumEntry

class ATL_NO_VTABLE EnumEntry
	: public CComObjectRootEx<CComSingleThreadModel>
	, public IEnumVARIANT
	, public IEnumFileEntry
{
public:
	EnumEntry()
		: m_bIEnumVARIANT(false)
		, m_bIEnumFileEntry(false)
	{}
	~EnumEntry()
	{
		if(NULL != m_info.hSrch)
		{
			Recls_SearchClose(m_info.hSrch);
		}
	}

	void SetVoid(void *pv)
	{
		SearchInfo	&src = *(SearchInfo*)pv;

		m_info		=	src;
		src.hSrch	=	NULL;
	}

	void SetProgress(LPUNKNOWN punkProgress);

DECLARE_PROTECT_FINAL_CONSTRUCT()

	static HRESULT WINAPI QueryFunc(void *pv, REFIID riid, LPVOID *ppv, DWORD dw);

BEGIN_COM_MAP(EnumEntry)
	COM_INTERFACE_ENTRY2(IUnknown, IEnumVARIANT)
	COM_INTERFACE_ENTRY_FUNC(IID_IEnumVARIANT, 0, EnumEntry::QueryFunc)
	COM_INTERFACE_ENTRY_FUNC(IID_IEnumFileEntry, 0, EnumEntry::QueryFunc)
END_COM_MAP()

// IEnumXXXX
public:
    STDMETHOD(Skip)(/* [in] */ ULONG celt);
    STDMETHOD(Reset)();

// IEnumVARIANT
public:
    STDMETHOD(Next)(/* [in] */ ULONG celt,
					/* [length_is][size_is][out] */ VARIANT *rgVar,
					/* [out] */ ULONG *pceltFetched);
    STDMETHOD(Clone)(/* [out] */ IEnumVARIANT **ppEnum);

// IEnumFileEntry
public:
    STDMETHOD(Next)(/* [in] */ ULONG celt,
					/* [length_is][size_is][out] */ PFILEENTRY *rgVar,
					/* [out] */ ULONG *pceltFetched);
    STDMETHOD(Clone)(/* [out] */ IEnumFileEntry **ppEnum);

// Implementation
private:
	HRESULT DoSkip();
    HRESULT	DoNext(VARIANT *pvar);
    HRESULT	DoNext(PFILEENTRY *pvar);

// Members
private:
	SearchInfo				m_info;
	IFileSearchProgress_ptr	m_fsp;
	bool					m_bIEnumVARIANT;
	bool					m_bIEnumFileEntry;
};

#endif //__ENUMENTRY_H_

////////////////////////////////////////////////////////////////////////////////
