////////////////////////////////////////////////////////////////////////////////
// SearchCollection.h : Declaration of the SearchCollection
//
// Updated: 3rd December 2005

#ifndef __SEARCH_H_
#define __SEARCH_H_

#include "resource.h"       // main symbols

////////////////////////////////////////////////////////////////////////////////
// SearchCollection - the collection class

class ATL_NO_VTABLE SearchCollection
	: public CComObjectRootEx<CComSingleThreadModel>
	, public CComCoClass<SearchCollection>
	, public IDispatchImpl<ISearchCollection, &IID_ISearchCollection, &LIBID_RECLS_COMLib>
{
public:
	~SearchCollection()
	{
		if(NULL != m_info.hSrch)
		{
			Recls_SearchClose(m_info.hSrch);
		}
	}

	void SetVoid(void *pv)
	{
		SearchInfo	&src = *(SearchInfo*)pv;

		m_info		=	src;
		src.hSrch	=	NULL;
	}

	void SetProgress(LPUNKNOWN punkProgress);

DECLARE_REGISTRY_RESOURCEID(IDR_FILESEARCH)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(SearchCollection)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISearchCollection)
END_COM_MAP()

// ISearchCollection
private:
	STDMETHOD(get__NewEnum)(LPUNKNOWN *ppen);

// Members
private:
	SearchInfo				m_info;
	IFileSearchProgress_ptr	m_fsp;
};

////////////////////////////////////////////////////////////////////////////////

#endif //__SEARCH_H_

////////////////////////////////////////////////////////////////////////////////
