////////////////////////////////////////////////////////////////////////////////
// stdafx.h : include file for standard system include files,
//      or project specific include files that are used frequently,
//      but are changed infrequently
//
// Updated: 26th December 2005

#if !defined(AFX_STDAFX_H__DD14AC30_3838_46D7_9111_6FBB45B09FEF__INCLUDED_)
#define AFX_STDAFX_H__DD14AC30_3838_46D7_9111_6FBB45B09FEF__INCLUDED_

#if _MSC_VER > 1000
# pragma once
# pragma warning(disable : 4530)
#endif // _MSC_VER > 1000

#define STRICT
#ifndef _WIN32_WINNT
# define _WIN32_WINNT 0x0400
#endif
#define _ATL_APARTMENT_THREADED

#include <atlbase.h>
//You may derive a class from CComModule and use it if you want to override
//something, but do not change the name of _Module

class ReclsModule
	: public CComModule
{
public:
	void OnObjectConstruct();
	void OnObjectDestroy();

	long	CurrentNumberOfObjects() const;
	long	TotalNumberOfObjects() const;
};

extern ReclsModule _Module;
#include <atlcom.h>



////////////////////////////////////////////////////////////////////////////////

#include <recls/recls.h>

using recls::hrecls_t;
using recls::recls_rc_t;
using recls::info_t;
using recls::recls_char_t;
using recls::recls_fileinfo_t;
using recls::recls_time_t;
using recls::recls_filesize_t;
using recls::recls_uint32_t;
using recls::recls_strptrs_t;
using recls::recls_root_t;
using recls::recls_process_fn_param_t;

using recls::RECLS_FAILED;
using recls::RECLS_SUCCEEDED;

using recls::Recls_Search;
using recls::Recls_SearchFeedback;
using recls::Recls_SearchClose;
using recls::Recls_GetNext;
using recls::Recls_GetDetails;
using recls::Recls_GetNextDetails;
using recls::Recls_CloseDetails;

using recls::Recls_GetErrorString;

using recls::Recls_GetPathProperty;
using recls::Recls_GetDirectoryProperty;
using recls::Recls_GetDirectoryPathProperty;
using recls::Recls_GetUNCDriveProperty;
using recls::Recls_GetFileProperty;
using recls::Recls_GetShortFileProperty;
using recls::Recls_GetFileNameProperty;
using recls::Recls_GetFileExtProperty;
using recls::Recls_GetDirectoryPartProperty;
using recls::Recls_GetFileProperty;
using recls::Recls_GetSizeProperty;
using recls::Recls_IsFileReadOnly;
using recls::Recls_IsFileDirectory;
using recls::Recls_IsFileLink;
using recls::Recls_IsFileUNC;
using recls::Recls_GetSearchDirectoryProperty;
using recls::Recls_GetSearchRelativePathProperty;

using recls::Recls_GetRoots;
using recls::Recls_GetPathNameSeparator;
using recls::Recls_GetPathSeparator;
using recls::Recls_GetWildcardsAll;

#include <recls/ftp.h>

using recls::Recls_SearchFtp;

////////////////////////////////////////////////////////////////////////////////

#include <stlsoft/auto_buffer.hpp>
#include <stlsoft/proxy_sequence.hpp>
#include <stlsoft/ref_ptr.hpp>

#include <comstl/task_allocator.hpp>
#include <comstl/errorinfo_functions.h>
#include <comstl/interface_cast.hpp>

#include <winstl/char_conversions.hpp>

#include <atlstl/property_method_helpers.hpp>
#include <atlstl/support_error_info.hpp>

////////////////////////////////////////////////////////////////////////////////

/// Sets the COM error info based on the message associated with the recls return code
inline void set_error_info_from_recls_rc_t(recls_rc_t rc)
{
	typedef stlsoft::auto_buffer<recls_char_t, comstl::task_allocator<recls_char_t>, _MAX_PATH>	buffer_t;

	buffer_t	buffer(1 + Recls_GetErrorString(rc, NULL, 0));

	Recls_GetErrorString(rc, &buffer[0], buffer.size());

#ifdef RECLS_CHAR_TYPE_IS_CHAR
	comstl::set_error_info(winstl::a2w(buffer.data()));
#elif defined(RECLS_CHAR_TYPE_IS_WCHAR)
	comstl::set_error_info(buffer.data());
#endif /* RECLS_CHAR_TYPE_IS_WCHAR */
}

////////////////////////////////////////////////////////////////////////////////

struct	IFileSearchProgress;

typedef stlsoft_ns_qual(ref_ptr)<IFileSearchProgress, IUnknown>	IFileSearchProgress_ptr;

////////////////////////////////////////////////////////////////////////////////

struct SearchInfo
{
	hrecls_t				hSrch;
	CComBSTR				searchRoot;
	CComBSTR				pattern;
	long					flags;
	bool					bEmpty;

	SearchInfo()
		: hSrch(NULL)
		, bEmpty(false)
	{}
};

////////////////////////////////////////////////////////////////////////////////

recls_rc_t call_Search(LPCOLESTR searchRoot, LPCOLESTR pattern, long flags, LPUNKNOWN punkProgress, hrecls_t *phSrch);

////////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__DD14AC30_3838_46D7_9111_6FBB45B09FEF__INCLUDED)

////////////////////////////////////////////////////////////////////////////////
