/* /////////////////////////////////////////////////////////////////////////////
 * File:		recls_ReclsException.cpp
 *
 * Purpose:     JNI implementation file for the ReclsException class
 *
 * Created      21st November 2003
 * Updated:     24th December 2005
 *
 * Copyright:	Synesis Software Pty Ltd, (c) 2003-2005. All rights reserved.
 *
 * Home:		www.synesis.com.au/software
 *
 * ////////////////////////////////////////////////////////////////////////// */


#include <recls_ReclsException.h>

#include <recls/recls.h>
#if defined(RECLS_PLATFORM_IS_WIN32)
# include <recls_win32.h>
#elif defined(RECLS_PLATFORM_IS_UNIX)
# include <recls_unix.h>
#else
# error Platform not (yet) recognised
#endif /* platform */

#include "recls_jni_util.h"

#include <stlsoft/auto_buffer.hpp>
#include <stlsoft/malloc_allocator.hpp>

/* ////////////////////////////////////////////////////////////////////////// */

#if !defined(RECLS_NO_NAMESPACE)
using recls::Recls_GetErrorString;
#endif /* !RECLS_NO_NAMESPACE */

typedef	stlsoft_ns_qual(auto_buffer)<	recls_char_t
									,	stlsoft_ns_qual(malloc_allocator)<recls_char_t>
									,	512
									>		buffer_t;

/* ////////////////////////////////////////////////////////////////////////// */

 /*
 * Class:     org_recls_ReclsException
 * Method:    translateCode
 * Signature: (I)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_org_recls_ReclsException_translateCode
  (JNIEnv *henv , jclass cls, jint code)
{
	size_t		cch		=	Recls_GetErrorString(code, NULL, 0);
	buffer_t	buffer(1 + cch);

	Recls_GetErrorString(code, &buffer[0], buffer.size());

#ifdef RECLS_CHAR_TYPE_IS_CHAR
	return henv->NewStringUTF(&buffer[0]);
#elif defined(RECLS_CHAR_TYPE_IS_WCHAR
	return henv->NewString(&buffer[0]);
#else /* ?char type */
# error recls char type must be discriminated
#endif /* char type */
}

/* ////////////////////////////////////////////////////////////////////////// */

